#include "Calculations.h"

#include <math.h>
//#include "TimerServer.h"
//#include "D3DGraphics.h"

float CalcSpeed(  float speed )
{
	/*TimerClient tc;
	return speed * tc.GetFrameTime() / 1000;*/
	return 1.0f;
}

float CalcRise( float y1, float y2 )
{
	return y2 - y1;	
}

float CalcRun( float x1, float x2 )
{
	return x2 - x1;
}

float CalcDistance( Coord *src1, Coord *src2)
{
	return sqrt(((src2->y - src1->y) * (src2->y - src1->y))  + ((src2->x - src1->x) * (src2->x - src1->x)));
}

float CalcSlope( float rise, float run )
{
	if(rise > run)
	{
		return run / rise;
	}
	else if(rise < run)
	{
		return rise / run;
	}
	else
	{
		return 1.0f;
	}
}

float CalcSlopeToAngle( float slope )
{
	return atan(slope);
}

Coord CalcAngleToSlope( int angle )
{	
	Coord c = {0};
	angle %= 360;

	// Calculate c.x
	//if(45 <= angle && angle <= 135)
	//{
	//	c.x = 1;
	//}
	//else if(225 <= angle && angle <= 315)
	//{
	//	c.x = -1;
	//}
	//else if(angle == 0 || angle == 180 || angle == 360)
	//{
	//	c.x = 0;
	//}
	//else
	//{
	//	c.x = tan( CalcDegToRad( 45 + ((angle % 90) - 45) ) );
	//}
	////// Calculate c.y
	//if(135 <= angle && angle <= 225)
	//{
	//	c.y = 1;
	//}
	//else if(315 <= angle || angle <= 45)
	//{
	//	c.y = -1;
	//}
	//else if(angle == 90 || angle == 270 )
	//{
	//	c.y = 0;
	//}
	//else
	//{
	//	if( (angle > 45 && angle < 90) || (angle > 225 && angle < 270) )
	//	{
	//		c.y = tan(CalcDegToRad( 45 - ( (angle % 90) - 45 ) ) );
	//	}
	//	c.y = tan(CalcDegToRad( (angle % 90) - 45 ));
	//}
	
	if(angle == 0 || angle == 360)
	{
		c.x = 0;
		c.y = -1;
	}
	else if( 0 < angle && angle < 45 )
	{
		c.x = tan(CalcDegToRad(angle));
		c.y = -1;
	}
	else if( angle == 45 )
	{
		c.x = 1;
		c.y = -1;
	}
	else if(  45 < angle && angle < 90 )
	{
		c.x = 1;
		c.y = tan(CalcDegToRad( angle - 90) );
	}	
	else if(angle == 90)
	{
		c.x = 1;
		c.y = 0;
	}
	else if( angle > 90 &&  angle < 135 )
	{
		c.x = 1;
		c.y = tan(CalcDegToRad( angle - 90) );
	}
	else if(angle == 135 )
	{
		c.x = 1;
		c.y = 1;
	}
	else if( angle > 135 &&  angle < 180 )
	{
		c.x = tan( CalcDegToRad( 180 - angle ) );
		c.y = 1;
	}
	else if(angle == 180)
	{
		c.x = 0;
		c.y = 1;
	}
	else if(angle > 180 &&  angle < 225 )
	{
		c.x = -tan(CalcDegToRad( angle ));
		c.y = 1;
	}
	else if( angle == 225 )
	{
		c.x = -1;
		c.y = 1;
	}
	else if(225 < angle && angle < 270)
	{
		c.x = -1;
		c.y = tan(CalcDegToRad( 270 - angle ) );
	}
	else if(angle == 270)
	{
		c.x = -1;
		c.y = 0;
	}
	else if(270 < angle && angle < 315 )
	{
		c.x = -1;
		c.y = -tan( CalcDegToRad( angle - 270 ) );
	}
	else if(angle == 315 )
	{
		c.x = -1;
		c.y = -1;
	}
	else if( 315 < angle && angle < 360 )
	{
		c.x = tan( CalcDegToRad( angle - 180) );
		c.y = -1;
	}
	return c;
}

//float CalcAngleToRun( int angle )
//{	
//	if( angle == 360 || angle == 0 || angle == 180 )
//	{
//		return 0;
//	}
//	else
//	{
//		if( angle < 180 )
//		{
//			return 1;
//		}
//		else
//		{
//			return -1;
//		}
//	}
//}

float CalcDegToRad( int angleDegree )
{
	return angleDegree * (3.14159f / 180);
}

Coord CalcScreenRatio( Coord coord )
{
	Coord c; 
	/*c.x = SCREENWIDTH / coord.x;
	c.y = SCREENHEIGHT / coord.y;*/
	return c;

}

Coord CoordSceenRes( Coord coord, Coord scrn )
{
	Coord c = CalcScreenRatio( scrn );
	c.x *= coord.x;
	c.y *= coord.y;
	return c;	
}

Coord GameToScreenCoord( Coord coord, Coord scrn, Coord cam )
{
	Coord c;
	c.x = cam.y - coord.x;
	c.y = cam.y - coord.y;	
	c = CoordSceenRes( c, scrn );
	return c;
}
