#include "Camera.h"
#include "TimerServer.h"

Camera::Camera( int startX, int startY, unsigned int scrnWidth, unsigned int scrnHeight)
{
	viewport.x1 = startX;
	viewport.y1 = startY;
	viewport.x2 = startX + scrnWidth;
	viewport.y2 = startY + scrnHeight;
	cam.x = startX;
	cam.y - startY;
	speed = 35;
	fTimer = 0;
}

D3DRECT Camera::GetViewport()
{
	return viewport;	
}

void Camera::Do( )
{
	UpdateTimer( );
	float temp = CalcSpeed(  speed );
	temp = min( 1, temp);
	if(viewport.y1 - temp > 0)
	{
		viewport.y1 -= temp;
	}

	cam.y = viewport.y1;
}

void Camera::UpdateTimer()
{
	TimerClient tc;
	fTimer = tc.GetFrameTime();
}

Coord Camera::GetCoord()
{
	return cam;
}

