#pragma once

// #include <windows.h>
#include "Trigger.h"
#include "D3DGraphics.h"
class Level
{
public:

	Level(D3DGraphics &gfx);
	~Level();

	LPCTSTR GetBGImg();
	LPCTSTR GetBGAud();
	void ClearTrigger( bool passedTrigger );

	Trigger *GetTrigger( unsigned int index );
	unsigned int GetCurrentTrigger();
	unsigned int GetNumEnemyTriggers();
	unsigned int GetLWidth() const;
	unsigned int GetLHeight() const;
	
protected:
	// File names of background image and background music
	LPCTSTR imgFile;
	LPCTSTR audFile;
	unsigned int numEnemySpawns;
	Trigger *eSpawn;
	Trigger eBoss;
	Trigger aSpawn;
	Trigger **triggerList;
	unsigned int currentTrigger;
	unsigned int lWidth, lHeight;
};

class Level1 : public Level
{
public:
	Level1(D3DGraphics &gfx);
};

class Level2 : public Level
{
public:
	Level2(D3DGraphics &gfx);
};

class Level3 : public Level
{
public:
	Level3(D3DGraphics &gfx);
};

class Level4 : public Level
{
public:
	Level4(D3DGraphics &gfx);
};

class Level5 : public Level
{
public:
	Level5(D3DGraphics &gfx);
};

class Level6 : public Level
{
public:
	Level6(D3DGraphics &gfx);
};

class Level7 : public Level
{
public:
	Level7(D3DGraphics &gfx);
};

class Level8 : public Level
{
public:
	Level8(D3DGraphics &gfx);
};
