#pragma once

#include <vector>
// Includes for game objects
#include "Asteroid.h"
#include "Camera.h"
#include "Level.h"
#include "Ship.h"
#include "ScoreController.h"

// Inlcudes for framework
#include "D3DGraphics.h"
#include "Input.h"

class StateCore
{
public:
	StateCore(D3DGraphics &gfx, Input &user);
	~StateCore();

	D3DGraphics &gfx;
	Input &user;
	std::vector<Projectile *> ammo;
	std::vector<Asteroid *>asteroid;
	std::vector< Enemy *>enemy;

	Level *level;
	Camera cam;
	Player player;
	Enemy *boss;
	ScoreController cScore;
};