#pragma once
#include <string>
#include "D3DGraphics.h"
#include "Input.h"
class Button
{
public:	
	Button();
	Button(D3DGraphics::Color color, unsigned int x, unsigned int y, 
		unsigned int width, unsigned int height, std::string text);
	void Draw(D3DGraphics &gfx);
	bool ButtonClicked(Input &user, D3DGraphics &gfx );
	const char*GetText()const;
private:
	std::string Text;
	unsigned int X, Y, X2, Y2;
	D3DGraphics::Color c;
	D3DGraphics::Font font;
};