#pragma once

struct Coord
{
	float x,y;
};

float CalcSpeed( float speed );
float CalcRise( float y1, float y2 );
float CalcRun( float x1, float x2 );
float CalcSlope( float rise, float Run );
float CalcDistance( Coord *src1, Coord *src2);
float CalcSlopeToAngle( float slope );
Coord CalcAngleToSlope( int angle );
//float CalcAngleToRun( int angle );    <- fixed CalcAngleToSlope to return X and Y values, so func not needed.
float CalcDegToRad( int angleDegree );
Coord CalcScreenRatio( Coord coord ); 
Coord CoordSceenRes( Coord coord, Coord scrn );
Coord GameToScreenCoord( Coord coord, Coord scrn, Coord cam );
