#include "Loading.h"
#include "Play.h"

Loading::Loading(StateController &sc, StateCore &core)
:
GameState(sc, core)
{
}

void Loading::Do()
{
	BeginFrame();
	switch (sc.GetCurrentLevel())
	{
	case 1:
		sc.SetLevel(new Level1(core.gfx));
		break;
	case 2:
		sc.SetLevel(new Level2(core.gfx));
		break;
	case 3:
		sc.SetLevel(new Level3(core.gfx));
		break;
	case 4:
		sc.SetLevel(new Level4(core.gfx));
		break;
	case 5:
		sc.SetLevel(new Level5(core.gfx));
		break;
	case 6:
		sc.SetLevel(new Level6(core.gfx));
		break;
	case 7:
		sc.SetLevel(new Level7(core.gfx));
		break;
	case 8:
		sc.SetLevel(new Level8(core.gfx));
		break;
	}
	ComposeFrame();

	sc.Transition(new Play(sc, core));
}

/*
void Loading::LoadLevel()
{
// Set player stats
Player *p = new Player;
float temp = 1.0f - p->GetHealth();
p1Ship.SetPosition( camera.vx, camera.vy );
p1Ship.SetHealth( -temp );
temp = 1.0f - p1Ship.GetShieldStrength();
p1Ship.SetShieldStrength( -temp );
p1Ship.SetScreenRes(SCREENWIDTH, SCREENHEIGHT);

Level::Trigger bTrigger = level.GetTrigger(level.GetNumEnemyTriggers() + 1);
boss1.SetPosition(bTrigger.x, bTrigger.y);
boss2.SetPosition(bTrigger.x, bTrigger.y);
}
*/

