#pragma once

#include "StateCore.h"
class GameState;

class StateController
{
public:
	StateController( StateCore &core);
	~StateController();
	void Transition( GameState *pNewState);
	void SetLevel( Level *l );
	void Do();
	unsigned int GetCurrentLevel()const;
	Level *GetLevel() const;
private:
	GameState *state;
	Level *level;
	unsigned int currentLevel;
	bool isPaused;
	StateCore &core;
};
