#include "StateCore.h"

StateCore::StateCore(D3DGraphics &gfx, Input &user)
		:
	gfx(gfx),
	user(user),
	level(new Level1(gfx)),
	cam(0, level->GetLHeight() - gfx.GetHeight(), gfx.GetWidth(), gfx.GetHeight()),
	player(user, *this)
	{
		
		
	}

StateCore::~StateCore()
{
	for(int i = 0; i < ammo.size(); i++)
	{
		delete ammo[ i ];
		ammo[ i ] = nullptr;
		ammo.clear();
	}
	for(int i = 0; i < asteroid.size(); i++)
	{
		delete asteroid[ i ];
		asteroid[ i ] = nullptr;
		asteroid.clear();
	}
	for(int i = 0; i < enemy.size(); i++)
	{
		delete enemy[ i ];
		enemy[ i ] = nullptr;
		enemy.clear();
	}
}