#include "Trigger.h"

Trigger::Trigger(float x, float y)
	:
	x(x),
	y(y),
	passed(false)
{
}

void Trigger::ClearTrigger()
{
	passed = true;
}

void Trigger::Set(float X, float Y)
{
	x = X;
	y = Y;
}

bool Trigger::IsAtTrigger( float px, float py)
{	
	return py <= y;
}

Trigger::~Trigger()
{
}

ATrigger::ATrigger( float x, float y)
	:
	Trigger(x, y)
{
	passed = false;
}

ETrigger::ETrigger( float x, float y)
	:
	Trigger(x, y)
{
	passed = false;
}

BTrigger::BTrigger( float x, float y)
	:
	Trigger(x, y)
{
	passed = false;
}

